# open this flag when support more pkg
%bcond_with tests

%global srcname  pytest-cov
%global slugname pytest_cov
%global common_description %{expand:
This plugin produces coverage reports. Compared to just using coverage run this plugin does some
extras:

  • Subprocess support: you can fork or run stuff in a subprocess and will get covered without any
    fuss.
  • Xdist support: you can use all of pytest-xdist’s features and still get coverage.
  • Consistent pytest behavior. If you run coverage run -m pytest you will have slightly different
    sys.path (CWD will be in it, unlike when running pytest).

All features offered by the coverage package should work, either through pytest-cov’s command line
options or through coverage’s config file.}

Summary:       Coverage plugin for pytest
Name:          python-%{srcname}
Version:       4.1.0
Release:       3%{?dist}
License:       MIT
URL:           https://github.com/pytest-dev/pytest-cov
Source0:       %{url}/pytest-cov/archive/refs/tags/v%{version}.tar.gz#/pytest-cov-%{version}.tar.gz

BuildRequires: python3-devel pyproject-rpm-macros

BuildArch:     noarch

%description %{common_description}

%package -n python3-%{srcname}
Summary:        Coverage plugin for pytest

%description -n python3-%{srcname} %{common_description}

%prep
%autosetup -n %{srcname}-%{version} -p1
sed -r -i '/^[[:blank:]]*.hunter.,[[:blank:]]*$/d' setup.py

%generate_buildrequires
%pyproject_buildrequires -r %{?with_tests:-x testing}

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files %{slugname}

%if %{with tests}
%check
k="$(awk 'NR>1 {pre=" and " } { printf "%snot %s", pre, $0 }' <<EOF
test_append_coverage_subprocess
test_central_subprocess
test_cleanup_on_sigterm
test_dist_missing_data
test_dist_subprocess_collocated
test_dist_subprocess_not_collocated
test_subprocess_with_path_aliasing
EOF
)"
%pytest -k "${k}"
%endif

%files -n python3-%{srcname} -f %{pyproject_files}
%license LICENSE
%doc *.rst
%{python3_sitelib}/%{srcname}.pth

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.1.0-3
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.1.0-2
- Rebuilt for loongarch release

* Tue Sep 26 2023 jackeyji <jackeyji@tencent.com> - 4.1.0-1
- upgrade to 4.1.0

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.0-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.0-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Feb 10 2023 Shuo Wang <abushwang@tencent.com> - 4.0.0-1
- initial build
